﻿/*
	This file is used to load DFFS with JSLink in SP 2013.
*/
Type.registerNamespace('spjs');
spjs.dffsJSLink = {
    "version": "1.1.10",
    "lastMod": "August 26, 2020",
    "data": { "mds": false, "overlay": { "img": null, "bgImg": null, "bgColor": null } },
    "loadOverlay": function (ctx) {
        if (document.forms[MSOWebPartPageFormName].MSOLayout_InDesignMode.value !== "1") {
            var ft = document.querySelectorAll("table.ms-formtable")[0], div, b = [], co, script, w = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth, rHandler;
            try {
                if (ft !== undefined) {
                    ft.style.position = "relative";
                    ft.style.left = "-10000px";
                }
                div = document.createElement('div');
                div.id = "dffs_loadingOverlay";
                b.push("width:10000px;height:10000px;overflow:hidden;position:fixed;top:0px;cursor:default;z-index:8888;");
                if (spjs.dffsJSLink.data.overlay.bgColor !== null) {
                    b.push("background-color:" + spjs.dffsJSLink.data.overlay.bgColor + ";");
                } else {
                    b.push("background-color:#F5F5F5;");
                }
                if (spjs.dffsJSLink.data.overlay.bgImg !== null) {
                    if (spjs.dffsJSLink.data.overlay.bgImg !== "") {
                        b.push("background-image:url(" + spjs.dffsJSLink.data.overlay.bgImg + ");");
                    }
                } else {
                    b.push("background-image:url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAYAAAAGCAYAAADgzO9IAAAALElEQVQIW2NkwALOnDnznxFdHCRoYmLCiCIBEwQphksgC8Il0AXBEtgEQRIAsDsXagWOqrQAAAAASUVORK5CYII=);");
                }
                div.style.cssText = b.join("");
                b = [];
                b.push("<div id='dffs_loader_img' style='width:" + w + "px;text-align:center;padding-top:100px;'>");
                if (spjs.dffsJSLink.data.overlay.img !== null) {
                    b.push("<img src='" + spjs.dffsJSLink.data.overlay.img + "' style='border:none;'>");
                }
                b.push("</div>");
                div.innerHTML = b.join("");
                document.body.insertBefore(div, document.body.firstChild);
                // Center loader image
                rHandler = function (event) {
                    w = window.innerWidth || document.documentElement.clientWidth || document.body.clientWidth;
                    try {
                        document.getElementById("dffs_loader_img").style.width = w + "px";
                    } catch (ignore) {
                        // Nothing
                    }
                };
                try {
                    window.addEventListener('resize', rHandler);
                    setTimeout(function () {
                        window.removeEventListener('resize', rHandler);
                    }, 3000);
                } catch (ignore) { // IE8
                    window.attachEvent('onresize', rHandler);
                    setTimeout(function () {
                        window.detachEvent('onresize', rHandler);
                    }, 3000);
                }
                // remove form overlay
                co = document.getElementById("dffs_formTableOverlay");
                if (co !== null) {
                    co.parentElement.removeChild(co);
                }
                script = document.createElement('script');
                b = [];
                b.push("setTimeout(function(){");
                b.push("var oDiv = document.getElementById(\"dffs_loadingOverlay\");");
                b.push("if(oDiv !== null){");
                b.push("oDiv.innerHTML = \"<div style='font-size:20px;width:" + w + "px;text-align:center;padding-top:100px;'>This took forever!<br><span style='font-size:12px'>Try refreshing the page or contact an administrator.</span></div>\";");
                b.push("}");
                b.push("},10000);");
                script.innerHTML = b.join("");
                document.getElementsByTagName('head')[0].appendChild(script);
            } catch (ignore) {
                // Ignore
            }
        }
    },
    "listViewMsg": function (ctx) {
        try {
            document.getElementById("dffs_loadingOverlay").outerHTML = "";
        } catch (ignore) {
            // Nothing
        }
        return "<span style='color:red;'>Please remove this field from the list view as it breaks the  \"Minimal Download Strategy\" support.</span>";
    },
    "loadScripts": function (ctx) {
        var a = SPClientTemplates.Utility.GetFormContextForCurrentField(ctx), override = null, dffsSettings = null, path, plugins, pStatus = {}, script, link, scriptLoadCheck = { "m": 500, "t": 0 }, jLoaded, jLoadCheck = { "m": 500, "t": 0 }, isLoaded, head = document.getElementsByTagName('head')[0], loadPlugins, backend = GetUrlKeyValue("backend") === "1";
        try {
            override = window.JSON.parse(unescape(a.fieldSchema.Description));
            if (override.overlay.img !== undefined) {
                spjs.dffsJSLink.data.overlay.img = override.overlay.img;
            }
            if (override.overlay.bgImg !== undefined) {
                spjs.dffsJSLink.data.overlay.bgImg = override.overlay.bgImg;
            }
            if (override.overlay.bgColor !== undefined) {
                spjs.dffsJSLink.data.overlay.bgColor = override.overlay.bgColor;
            }
        } catch (ignore) {
            // nothing
        }
        spjs.dffsJSLink.loadOverlay();
        try {
            dffsSettings = window.JSON.parse(unescape(a.fieldSchema.Direction));
        } catch (err) {
            alert(err);
            return;
        }
        window.dffs_loadedWithJSLink = true;
        window.spjs_dffs_backend = dffsSettings.backend;
        window.spjs_dffs_jsLink_license = dffsSettings.license;
        window.dffsRequiredFieldValidation = dffsSettings.fieldValidatonMsg;
        if (dffsSettings.configListBaseUrl !== "" && dffsSettings.configListBaseUrl !== "{currentsite}") {
            window.dffs_configListBaseUrl = dffsSettings.configListBaseUrl;
        }
        window.vLookup_configListBaseUrl = dffsSettings.vLookupConfigListBaseUrl;
        window.rm_configListBaseUrl = dffsSettings.rmConfigListBaseUrl;
        window.dffs_formTypeSwitch = dffsSettings.formTypeSwitchField;
        switch (dffsSettings.scope) {
            case "site":
                path = (_spPageContextInfo.webServerRelativeUrl !== "/" ? _spPageContextInfo.webServerRelativeUrl + "/" : _spPageContextInfo.webServerRelativeUrl) + "SPJS/DFFS/";
                break;
            case "parentsite":
                path = _spPageContextInfo.webServerRelativeUrl.substring(0, _spPageContextInfo.webServerRelativeUrl.lastIndexOf("/") + 1) + "SPJS/DFFS/";
                break;
            case "sitecollection":
                path = (_spPageContextInfo.siteServerRelativeUrl !== "/" ? _spPageContextInfo.siteServerRelativeUrl + "/" : _spPageContextInfo.siteServerRelativeUrl) + "SPJS/DFFS/";
                break;
            case "custom":
                path = dffsSettings.customFileLocation;
                path = path.replace("~sitecollection", _spPageContextInfo.siteAbsoluteUrl);
                path = path.replace("~site", _spPageContextInfo.webAbsoluteUrl);
                if (path.charAt(path.length - 1) !== "/") {
                    path = path + "/";
                }
                break;
        }
        // Make the path globally availabel because it is used in some functions in DFFS
        spjs_path = path;
        // Add support for Minimal download strategy
        if (!spjs.dffsJSLink.data.mds) {
            spjs.dffsJSLink.data.mds = true;
            RegisterModuleInit(path + "jslink/DFFS_JSLink.js", spjs.dffsJSLink.overrideField);
        }
        if (spjs.dffsJSLink.data.overlay.img === null) {
            document.getElementById("dffs_loader_img").innerHTML = "<img src='" + path + "images/DFFS_loader.gif' />";
        }
        plugins = dffsSettings.plugins;
        // Check if all plugins have loaded successfully
        isLoaded = function (plugin) {
            var pass = true, fBuffer = [];
            jQuery.each(plugins, function (i, p) {
                pStatus[p] = true;
                if (spjs[p] === undefined) {
                    pStatus[p] = false;
                    pass = false;
                    scriptLoadCheck.t += 1;
                    if (scriptLoadCheck.t > scriptLoadCheck.m) {
                        pass = true;
                    }
                }
            });
            if (!pass) {
                setTimeout(function () {
                    isLoaded(dffsSettings.plugins);
                }, 10);
                return false;
            }
            jQuery.each(pStatus, function (id, p) {
                if (!p) {
                    if (id === "vLookup") {
                        id += GetUrlKeyValue("backend") === "1" ? "_backend" : "frontend";
                    }
                    fBuffer.push("SPJS-" + id + ".js");
                }
            });
            // Load DFFS frontend JS and CSS
            if (backend) {
                jQuery("#s4-workspace").hide();
                jQuery("body").prepend("<div id='dffs_backend' style='width:100%;height:100%;background-color:#f5f5f5;overflow:auto;position:absolute;top:0;left:0;z-index:9999;'></div>");
                script = document.createElement('script');
                script.src = path + "js/DFFS_backend_min.js";
                head.appendChild(script);
                link = document.createElement('link');
                link.type = "text/css";
                link.rel = "stylesheet";
                link.href = path + "css/DFFS_backend.css";
                head.appendChild(link);
                // Load ACE start
                script = document.createElement('script');
                script.src = path + "/ace/src-min-noconflict/ace.js";
                head.appendChild(script);
                script = document.createElement('script');
                script.src = path + "/beautify/beautify.js";
                head.appendChild(script);
                script = document.createElement('script');
                script.src = path + "/beautify/beautify-css.js";
                head.appendChild(script);
                jQuery("#dffs_loadingOverlay").remove();
            } else {
                script = document.createElement('script');
                script.src = path + "js/DFFS_frontend_min.js";
                head.appendChild(script);
                link = document.createElement('link');
                link.type = "text/css";
                link.rel = "stylesheet";
                link.href = path + "css/DFFS_frontend.css";
                head.appendChild(link);
            }
            // Custom plugins css
            if (dffsSettings.customPlugins !== undefined) {
                jQuery.each(dffsSettings.customPlugins.split("\n"), function (i, p) {
                    if (p.match(/\.css/i) !== null) {
                        link = document.createElement('link');
                        link.type = "text/css";
                        link.rel = "stylesheet";
                        link.href = path + "custom/" + p;
                        head.appendChild(link);
                    }
                });
            }
            if (fBuffer.length > 0) {
                alert("Failed to load DFFS-plugin(s):\n------------------------------------\n" + fBuffer.join("\n") + "\n\nEnsure you have these scripts in the \"DFFS\" folder in the document library \"SPJS\" here: " + makeAbsUrl(path));
            }
        };
        loadPlugins = function () {
            jQuery.each(plugins, function (i, p) {
                if (typeof spjs[p] === "undefined") {
                    if (p === "vLookup") {
                        if (backend) {
                            p = p + "_backend";
                        } else {
                            p = p + "_frontend";
                        }
                    }
                    script = document.createElement('script');
                    script.src = path + "plugins/SPJS-" + p + ".js";
                    head.appendChild(script);
                }
            });
            isLoaded(dffsSettings.plugins);
            // Custom plugins js
            if (dffsSettings.customPlugins !== undefined) {
                jQuery.each(dffsSettings.customPlugins.split("\n"), function (i, p) {
                    if (p.match(/\.js/i) !== null) {
                        script = document.createElement('script');
                        script.src = path + "custom/" + p;
                        head.appendChild(script);
                    }
                });
            }
        };
        jLoaded = function (init) {
            if (typeof jQuery !== "function") {
                if (init) {
                    script = document.createElement('script');
                    script.src = path + "plugins/jquery.js";
                    head.appendChild(script);
                    jLoaded(false);
                } else {
                    jLoadCheck.t += 1;
                    if (jLoadCheck.t > jLoadCheck.m) {
                        alert("Failed to load jQuery!\n\nEnsure you have jquery.js in the \"DFFS\" folder in the document library \"SPJS\" here: " + makeAbsUrl(path));
                    } else {
                        setTimeout(function () {
                            jLoaded(false);
                        }, 10);
                    }
                }
            } else {
                loadPlugins();
            }
        };
        jLoaded(true);
        setTimeout(function () {
            spjs.dffsJSLink.hideFields();
        }, 100);
        return "<span id='DFFSLoader'></span>";
    },
    "hideFields": function () {
        if (typeof jQuery !== "function") {
            setTimeout(function () {
                spjs.dffsJSLink.hideFields();
            }, 100);
            return;
        }
        jQuery("#DFFSLoader").parents("tr:first").remove();
    }
};

spjs.dffsJSLink.templateOverride = {};
spjs.dffsJSLink.templateOverride.Templates = {};
spjs.dffsJSLink.templateOverride.Templates.Fields = {
    "DFFS_Loader": {
        "View": spjs.dffsJSLink.listViewMsg,
        "NewForm": spjs.dffsJSLink.loadScripts,
        "DisplayForm": spjs.dffsJSLink.loadScripts,
        "EditForm": spjs.dffsJSLink.loadScripts
    }
};
spjs.dffsJSLink.overrideField = function () {
    SPClientTemplates.TemplateManager.RegisterTemplateOverrides(spjs.dffsJSLink.templateOverride);
};
spjs.dffsJSLink.overrideField();