var spjs_list_form_url = {
    "version": "1.0.0.0",
    "date": "August 12, 2020",
    "data": {
        "logListCounter": 0,
        "listsToCheckCounter": 0
    },
    "getFormDigest": function () {
        var r = _spPageContextInfo.formDigestValue;
        if (r === undefined) {
            r = jQuery("#__REQUESTDIGEST").val();
        }
        return r;
    },
    "getAllLists": function (baseUrl) {
        var d = jQuery.Deferred();
        jQuery.ajax({
            "url": baseUrl + "/_api/Web/Lists?$select=Id,Title,Rootfolder/Name&$expand=Rootfolder",
            "method": "GET",
            "headers": {
                "accept": "application/json; odata=verbose",
                "content-type": "application/json;odata=verbose",
                "X-RequestDigest": spjs_list_form_url.getFormDigest()
            },
            "success": function (data) {
                var listRootfolderToList = {};
                jQuery.each(data.d.results, function (i, o) {
                    listRootfolderToList[o.RootFolder.Name.toLowerCase()] = { "title": o.Title, "id": o.Id };
                });
                d.resolve(listRootfolderToList);
            },
            "error": function (err) {
                d.reject(err);
            }
        });
        return d.promise();
    },
    "getContentTypeFormUrl": function (siteBaseUrl, list) {
        jQuery.ajax({
            "url": siteBaseUrl + "/_api/web/lists/getbyid('" + list.id + "')/ContentTypes",
            "type": "GET",
            "headers": {
                "accept": "application/json;odata=verbose",
                "content-type": "application/json;odata=verbose"
            },
            "success": function (data) {
                console.log("*** " + list.title + " ***");
                jQuery.each(data.d.results, function (i, ct) {
                    if (ct.Sealed) {
                        return;
                    }
                    console.log("- " + ct.Name);
                    var idSubstr = ct.StringId.substring(0, 6);
                    switch (idSubstr) {
                        case "0x0100": // Item
                        case "0x0102": // Event
                        case "0x0103": // Issue
                        case "0x0104": // Announcement
                        case "0x0105": // Link
                        case "0x0106": // Contact
                        case "0x0107": // Message
                        case "0x0108": // Task
                        case "0x0110": // Post
                        case "0x0111": // Comment
                            console.log("   NewFormUrl: " + ct.NewFormUrl);
                            console.log("   DisplayFormUrl: " + ct.DisplayFormUrl);
                            console.log("   EditFormUrl: " + ct.EditFormUrl);
                            break;
                        case "0x0101": // Document
                            console.log("   DisplayFormUrl: " + ct.DisplayFormUrl);
                            console.log("   EditFormUrl: " + ct.EditFormUrl);
                            break;
                    }
                });
                spjs_list_form_url.checkProgress();
            },
            "error": function (err) {
                console.log(err);
            }
        });
    },
    "checkProgress": function () {
        spjs_list_form_url.data.logListCounter += 1;
        if (spjs_list_form_url.data.logListCounter === spjs_list_form_url.data.listsToCheckCounter) {
            console.log("*** Done with all lists in this site ***");
        }
    },
    "init": function () {
        if (typeof jQuery === "undefined") {
            setTimeout(function () {
                alert("This script requires jQuery to run. Please go to one of your DFFS enabled lists by typing in /Lists/YourList/NewForm.aspx in the browser address field and paste it in the console.");
            }, 100);
        } else {
            spjs_list_form_url.getAllLists(_spPageContextInfo.webAbsoluteUrl).done(function (listRootfolderToList) {
                jQuery.ajax({
                    "url": _spPageContextInfo.webAbsoluteUrl + "/_api/Web/Lists/getbytitle('SPJS-DynamicFormsForSharePoint')/items?$select=Title&$top=5000",
                    "method": "GET",
                    "headers": {
                        "accept": "application/json; odata=verbose",
                        "content-type": "application/json;odata=verbose",
                        "X-RequestDigest": spjs_list_form_url.getFormDigest()
                    },
                    "success": function (data) {
                        var dup = {}, allConfiguratedLists = [];
                        jQuery.each(data.d.results, function (i, item) {
                            var listRootfolder = item.Title.indexOf("/lists/") === 0 ? item.Title.split("/")[2] : item.Title.split("/")[1], list = listRootfolderToList[listRootfolder];
                            if (listRootfolder !== undefined && list !== undefined) {
                                if (dup[listRootfolder] === undefined) {
                                    dup[listRootfolder] = true;
                                    allConfiguratedLists.push({ "rootfolder": listRootfolder, "id": list.id, "title": list.title });
                                }
                            }
                        });
                        spjs_list_form_url.data.listsToCheckCounter = allConfiguratedLists.length;
                        jQuery.each(allConfiguratedLists, function (i, list) {
                            spjs_list_form_url.getContentTypeFormUrl(_spPageContextInfo.webAbsoluteUrl, list);
                        });
                    },
                    "error": function (err) {
                        console.log(err);
                    }
                });
            });
        }
    }
};

spjs_list_form_url.init();
// Clear console
console.clear();